<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRigaDelegaF24 ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfRigaDelegaF24
 * @subpackage Arrays
 */
class ArrayOfRigaDelegaF24 extends AbstractStructArrayBase
{
    /**
     * The RigaDelegaF24
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RigaDelegaF24[]
     */
    public $RigaDelegaF24;
    /**
     * Constructor method for ArrayOfRigaDelegaF24
     * @uses ArrayOfRigaDelegaF24::setRigaDelegaF24()
     * @param \StructType\RigaDelegaF24[] $rigaDelegaF24
     */
    public function __construct(array $rigaDelegaF24 = array())
    {
        $this
            ->setRigaDelegaF24($rigaDelegaF24);
    }
    /**
     * Get RigaDelegaF24 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RigaDelegaF24[]|null
     */
    public function getRigaDelegaF24()
    {
        return isset($this->RigaDelegaF24) ? $this->RigaDelegaF24 : null;
    }
    /**
     * Set RigaDelegaF24 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RigaDelegaF24[] $rigaDelegaF24
     * @return \ArrayType\ArrayOfRigaDelegaF24
     */
    public function setRigaDelegaF24(array $rigaDelegaF24 = array())
    {
        foreach ($rigaDelegaF24 as $arrayOfRigaDelegaF24RigaDelegaF24Item) {
            // validation for constraint: itemType
            if (!$arrayOfRigaDelegaF24RigaDelegaF24Item instanceof \StructType\RigaDelegaF24) {
                throw new \InvalidArgumentException(sprintf('The RigaDelegaF24 property can only contain items of \StructType\RigaDelegaF24, "%s" given', is_object($arrayOfRigaDelegaF24RigaDelegaF24Item) ? get_class($arrayOfRigaDelegaF24RigaDelegaF24Item) : gettype($arrayOfRigaDelegaF24RigaDelegaF24Item)), __LINE__);
            }
        }
        if (is_null($rigaDelegaF24) || (is_array($rigaDelegaF24) && empty($rigaDelegaF24))) {
            unset($this->RigaDelegaF24);
        } else {
            $this->RigaDelegaF24 = $rigaDelegaF24;
        }
        return $this;
    }
    /**
     * Add item to RigaDelegaF24 value
     * @throws \InvalidArgumentException
     * @param \StructType\RigaDelegaF24 $item
     * @return \ArrayType\ArrayOfRigaDelegaF24
     */
    public function addToRigaDelegaF24(\StructType\RigaDelegaF24 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RigaDelegaF24) {
            throw new \InvalidArgumentException(sprintf('The RigaDelegaF24 property can only contain items of \StructType\RigaDelegaF24, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->RigaDelegaF24[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RigaDelegaF24|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RigaDelegaF24|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RigaDelegaF24|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RigaDelegaF24|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RigaDelegaF24|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RigaDelegaF24
     */
    public function getAttributeName()
    {
        return 'RigaDelegaF24';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfRigaDelegaF24
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
